/********************************************************************/
/*                                                                  */
/*            L   I  QQ  U U I DD    W   W  A  RR    555            */
/*            L   I Q  Q U U I D D   W   W A A R R   5              */
/*            L   I Q  Q U U I D D   W W W AAA RR    55             */
/*            L   I Q Q  U U I D D   WW WW A A R R     5            */
/*            LLL I  Q Q  U  I DD    W   W A A R R   55             */
/*                                                                  */
/*                             b                                    */
/*                             bb  y y                              */
/*                             b b yyy                              */
/*                             bb    y                              */
/*                                 yy                               */
/*                                                                  */
/*                     U U       FFF  O   O  TTT                    */
/*                     U U       F   O O O O  T                     */
/*                     U U TIRET FF  O O O O  T                     */
/*                     U U       F   O O O O  T                     */
/*                      U        F    O   O   T                     */
/*                                                                  */
/********************************************************************/

/********************************************************************/
/* this software is protected by the GPL, see copying.txt           */
/********************************************************************/

/********************************************************************/
/* nom           : config.h                                         */
/* contenu       : chargement des donnees de configuration          */
/* date de modif : 3 mai 98                                         */
/********************************************************************/

#ifndef LIQUID_WAR_INCLUDE_CONFIG
#define LIQUID_WAR_INCLUDE_CONFIG

/*==================================================================*/
/* includes                                                         */
/*==================================================================*/

#include "base.h"

/*==================================================================*/
/* variables globales                                               */
/*==================================================================*/

/*------------------------------------------------------------------*/
/* variables du fichier de configuration                            */
/*------------------------------------------------------------------*/

#define SERVER_ADDRESS_SIZE 50

extern int CONFIG_GFX_GAME;
extern int CONFIG_GFX_MENU;
extern int CONFIG_VIEWPORT_SIZE;
extern int CONFIG_WAVE_NUMBER[4];
extern int CONFIG_WAVE_AMPLI[4];
extern int CONFIG_WAVE_SPEED[4];
extern int CONFIG_BRIGHTNESS;
extern int CONFIG_CURSOR_INCREASE_SPEED;
extern int CONFIG_FIGHTER_ATTACK;
extern int CONFIG_FIGHTER_DEFENSE;
extern int CONFIG_FIGHTER_NEW_HEALTH;
extern int CONFIG_NUMBER_INFLUENCE;
extern int CONFIG_SFX_VOLUME;
extern int CONFIG_CLICK_VOLUME;
extern int CONFIG_WATER_VOLUME_MENU;
extern int CONFIG_WATER_VOLUME_GAME;
extern int CONFIG_LEVEL_MAP;
extern int CONFIG_LEVEL_FG;
extern int CONFIG_LEVEL_BG;
extern int CONFIG_FIGHTER_NUMBER;
extern int CONFIG_KEY_UP[NB_TEAMS];
extern int CONFIG_KEY_LEFT[NB_TEAMS];
extern int CONFIG_KEY_DOWN[NB_TEAMS];
extern int CONFIG_KEY_RIGHT[NB_TEAMS];
extern int CONFIG_TEAM_COLOR[NB_TEAMS];
extern int CONFIG_CPU_CONTROL[NB_TEAMS];
extern int CONFIG_GAME_TIME;
extern int CONFIG_INFO_BAR;
extern int CONFIG_MOUSE_GAP;
extern int CONFIG_JOYSTICK_ON;
extern int CONFIG_CPU_ADVANTAGE;
extern int CONFIG_PAGE_FLIP;
extern int CONFIG_LANGAGE;
extern int CONFIG_WAVE_ON;
extern int CONFIG_FRAMES_PER_SEC_LIMIT;
extern int CONFIG_ROUNDS_PER_SEC_LIMIT;
extern char CONFIG_NICKNAME[NICKNAME_SIZE+1];
extern char CONFIG_SERVER_ADDRESS[SERVER_ADDRESS_SIZE+1];
extern int CONFIG_SERVER_PORT;

/*==================================================================*/
/* constantes globales                                              */
/*==================================================================*/

extern int DISPLAY_DELAY_MIN[9];
extern int LOGIC_DELAY_MIN[9];

/*==================================================================*/
/* fonctions globales                                               */
/*==================================================================*/

void load_default_options (void);
int load_config_options (void);
int save_config_options (void);
void check_config_range (void);

#endif
