/********************************************************************/
/*                                                                  */
/*            L   I  QQ  U U I DD    W   W  A  RR    555            */
/*            L   I Q  Q U U I D D   W   W A A R R   5              */
/*            L   I Q  Q U U I D D   W W W AAA RR    55             */
/*            L   I Q Q  U U I D D   WW WW A A R R     5            */
/*            LLL I  Q Q  U  I DD    W   W A A R R   55             */
/*                                                                  */
/*                             b                                    */
/*                             bb  y y                              */
/*                             b b yyy                              */
/*                             bb    y                              */
/*                                 yy                               */
/*                                                                  */
/*                     U U       FFF  O   O  TTT                    */
/*                     U U       F   O O O O  T                     */
/*                     U U TIRET FF  O O O O  T                     */
/*                     U U       F   O O O O  T                     */
/*                      U        F    O   O   T                     */
/*                                                                  */
/********************************************************************/

/********************************************************************/
/* this software is protected by the GPL, see copying.txt           */
/********************************************************************/

/********************************************************************/
/* name          : network.h                                        */
/* content       : various network related stuff                    */
/* last update   : may 8th 2001                                     */
/********************************************************************/

#ifndef LIQUID_WAR_INCLUDE_NETWORK
#define LIQUID_WAR_INCLUDE_NETWORK

/*==================================================================*/
/* includes                                                         */
/*==================================================================*/

#include "base.h"

/*==================================================================*/
/* structs                                                          */
/*==================================================================*/

typedef struct 
{
  int active;
  int network;
  int server_id;
  char nickname[NICKNAME_SIZE];
  int color;
  int part;
} LW_WHO;

/*==================================================================*/
/* globals                                                          */
/*==================================================================*/

extern int LW_NETWORK_ON;
extern LW_WHO LW_NETWORK_INFO[NB_TEAMS];
extern int LW_NETWORK_ERROR_DETECTED;
extern void *LW_NETWORK_RAW_MAP;

/*==================================================================*/
/* functions                                                        */
/*==================================================================*/

extern void lw_network_attribute_colors();
extern void lw_network_attribute_parts();

#endif

